// Gex Library (C) 1999 by M.D.Schiller

// Version 2.1.0

// Dev. Start 18.5.1999


// Typen

struct _param {

    // Parameter
    int mode;
     // 1 - Windowed
     // 2 - Fullscreen
    int texturemanage;
    // 1 - Aus
    // 2 - An 
    int cooperative;
     // 1 - Normal
     // 2 - Exclusive
    int driver;
     // 1 - Hardware
     // 2 - Software
     // 3 - Selbst suchen
    int viewport;
     // 1 - Deaktivieren
     // 2 - Aktivieren

     // Status Informationen
     BOOL active;
      // Zeigt an ob alle Initialisierungen laufen
     int win_xsize;
      // X-Gre des Fensters
     int win_ysize;
      // Y-Gre des Fensters 
};

// 3D Hardware Objekt
class _device3d {
    private:
      HWND hWnd;
      LPDIRECTDRAW g_pDD1;
      LPDIRECTDRAW4 g_pDD4;
      LPDIRECTDRAWSURFACE4 g_pddsPrimary;
      LPDIRECTDRAWSURFACE4 g_pddsBackBuffer;
      LPDIRECTDRAWSURFACE4 g_pddsZBuffer;
      LPDIRECT3D3 g_pD3D;
      LPDIRECT3DDEVICE3  g_pd3dDevice;
      LPDIRECT3DVIEWPORT3 g_pvViewport;
      RECT g_rcScreenRect;
      RECT g_rcViewportRect;
      D3DRECT g_d3dScreenRect;

    public:
      _param param;
      void error( HRESULT hr , char * topic );
      HRESULT _device3d::init( HWND hWnd2 );
        // Initialisation von D3D
      HRESULT _device3d::initsurfaces();
        // Erstellt das Primary und Back Surface
      HRESULT _device3d::initdriver();
       // Initialisiert den Treiber   
      HRESULT _device3d::initviewport();
        // Initialisiert den Viewport
      HRESULT _device3d::initzbuffer();
       // Initialisiert den Z-Buffer  
      HRESULT _device3d::rebuild();
       // Initialisiert alles neu   
      HRESULT _device3d::deinit();
        // Deinitialisiert DirectX
      HRESULT _device3d::flip();
        // Kopiert den Backbuffer auf den Primarybuffer
      HRESULT _device3d::gettxtsurface( LPDIRECTDRAWSURFACE4 * g_pddsSurface, int width, int height, int bit );
        // Erzeugt ein Texturen Surface
      HRESULT _device3d::load( LPDIRECTDRAWSURFACE4 g_pddsSurface, LPDIRECT3DTEXTURE2 * lpD3DTexture2 );
        // Ein Texture Interface anfordern und Verbinden
      HRESULT _device3d::settexture( LPDIRECT3DTEXTURE2 lpD3DTexture2 );
        // Setzt das zu benutzende Texture
      HRESULT _device3d::drawtriangle( D3DTLVERTEX Vertex1, D3DTLVERTEX Vertex2, D3DTLVERTEX Vertex3 );
        // Zeichnet ein Triangle
      HRESULT _device3d::clear();
        // Lscht den Backbuffer
      HRESULT _device3d::beginscene();
        // Beginnt die Scene
      HRESULT _device3d::endscene();
        // Schliet die Scene
      HRESULT _device3d::drawline( D3DTLVERTEX Vertex1, D3DTLVERTEX Vertex2 );
        // Zeichnet eine Linie
      HRESULT _device3d::notexture();
        // Lscht aktuelles Texture aus der Pipline
      HRESULT _device3d::setcolorkey( LPDIRECTDRAWSURFACE4 g_pddsSurface, unsigned int color );
        // Setzt ein Colorkey
};


// Fehelerbehandlungsroutine
void _device3d::error( HRESULT hr , char * topic ) {
    char * txt;
    txt = "Unknown Error";
    if ( hr == D3DERR_BADMAJORVERSION ) txt = "D3DERR_BADMAJORVERSION";
    if ( hr == DDERR_INCOMPATIBLEPRIMARY ) txt = "DDERR_INCOMPATIBLEPRIMARY";
    if ( hr == DDERR_INVALIDCAPS) txt = "DDERR_INVALIDCAPS "; 
    if ( hr == DDERR_INVALIDOBJECT ) txt = "DDERR_INVALIDOBJECT  ";
    if ( hr == DDERR_INVALIDPARAMS ) txt = "DDERR_INVALIDPARAMS  ";
    if ( hr == DDERR_INVALIDPIXELFORMAT ) txt = "DDERR_INVALIDPIXELFORMAT  ";
    if ( hr == DDERR_NOALPHAHW ) txt = "DDERR_NOALPHAHW  ";
    if ( hr == DDERR_NOCOOPERATIVELEVELSET ) txt = "DDERR_NOCOOPERATIVELEVELSET  ";
    if ( hr == DDERR_NODIRECTDRAWHW ) txt = "DDERR_NODIRECTDRAWHW  ";
    if ( hr == DDERR_NOEMULATION ) txt = "DDERR_NOEMULATION  ";
    if ( hr == DDERR_NOEXCLUSIVEMODE ) txt = "DDERR_NOEXCLUSIVEMODE  ";
    if ( hr == DDERR_NOFLIPHW ) txt = "DDERR_NOFLIPHW  ";
    if ( hr == DDERR_NOMIPMAPHW ) txt = "DDERR_NOMIPMAPHW  ";
    if ( hr == DDERR_NOOVERLAYHW ) txt = "DDERR_NOOVERLAYHW ";
    if ( hr == DDERR_NOZBUFFERHW  ) txt = "DDERR_NOZBUFFERHW ";
    if ( hr == DDERR_OUTOFMEMORY  ) txt = "DDERR_OUTOFMEMORY ";
    if ( hr == DDERR_OUTOFVIDEOMEMORY  ) txt = "DDERR_OUTOFVIDEOMEMORY ";
    if ( hr == DDERR_PRIMARYSURFACEALREADYEXISTS ) txt = "DDERR_PRIMARYSURFACEALREADYEXISTS  ";
    if ( hr == DDERR_UNSUPPORTEDMODE ) txt = "DDERR_UNSUPPORTEDMODE";
    if ( hr == D3DERR_SCENE_BEGIN_FAILED  ) txt = "D3DERR_SCENE_BEGIN_FAILED";
    if ( hr == D3DERR_SCENE_END_FAILED  ) txt = "D3DERR_SCENE_END_FAILED";
    if ( hr == D3DERR_SCENE_IN_SCENE  ) txt = "D3DERR_SCENE_IN_SCENE";
    if ( hr == D3DERR_SCENE_NOT_IN_SCENE  ) txt = "D3DERR_SCENE_NOT_IN_SCENE";
    if ( hr == D3DERR_SCENE_IN_SCENE  ) txt = "D3DERR_STENCILBUFFER_NOTPRESENT ";
    if ( hr == D3DERR_VIEWPORTHASNODEVICE  ) txt = "D3DERR_VIEWPORTHASNODEVICE ";
    if ( hr == D3DERR_ZBUFFER_NOTPRESENT  ) txt = "D3DERR_ZBUFFER_NOTPRESENT ";
    if ( hr == DDERR_INVALIDOBJECT  ) txt = "DDERR_INVALIDOBJECT  ";
    if ( hr == DDERR_INVALIDPARAMS  ) txt = "DDERR_INVALIDPARAMS  ";
    MessageBox ( NULL , txt , topic ,MB_OK);
    // Weiteres Vorgehen
    //exit(0);
}

// Initialisierung des Viewports
HRESULT _device3d::initviewport() {

    HRESULT hr;

    // berprfen ob es schon einen gibt
    if( g_pvViewport ) g_pvViewport->Release();
    g_pvViewport = NULL; 
    
    // Set up the viewport data parameters
    D3DVIEWPORT2 vdData;
    ZeroMemory( &vdData, sizeof(D3DVIEWPORT2) );
    
    // Always set the structure size!
    vdData.dwSize       = sizeof(D3DVIEWPORT2);  
    vdData.dwWidth      = g_rcScreenRect.right - g_rcScreenRect.left;
    vdData.dwHeight     = g_rcScreenRect.bottom - g_rcScreenRect.top;
    vdData.dvClipX      = -1.0f;
    vdData.dvClipWidth  = 2.0f;
    vdData.dvClipY      = 1.0f;
    vdData.dvClipHeight = 2.0f;
    vdData.dvMaxZ       = 1.0f;

    // Create the viewport.
    hr = g_pD3D->CreateViewport( &g_pvViewport, NULL );
    if( FAILED( hr ) ) { error( hr, "D3D:CreateViewport" );return hr; }

    // Associate the viewport with the device.
    g_pd3dDevice->AddViewport( g_pvViewport ); 

    // Set the parameters for the new viewport.
    g_pvViewport->SetViewport2( &vdData );

    // Set the current viewport for the device
    g_pd3dDevice->SetCurrentViewport( g_pvViewport );

    return 0;
}

static HRESULT WINAPI EnumZBufferCallback( DDPIXELFORMAT* pddpf, VOID* pddpfDesired ){
    // If this is ANY type of depth-buffer, stop.
    if( pddpf->dwFlags == DDPF_ZBUFFER )    {
        memcpy( pddpfDesired, pddpf, sizeof(DDPIXELFORMAT) ); 
        // Return with D3DENUMRET_CANCEL to end the search.
        return D3DENUMRET_CANCEL;
    } 
    // Return with D3DENUMRET_OK to continue the search.
    return D3DENUMRET_OK;
}
    

// Init des Z-Buffers
HRESULT _device3d::initzbuffer() {
    HRESULT hr;
    DDSURFACEDESC2 ddsd;
    GUID pDeviceGUID;

    pDeviceGUID = IID_IDirect3DHALDevice;

    if( g_pddsZBuffer ) g_pddsZBuffer->Release();
    g_pddsZBuffer = NULL;
    
    DDPIXELFORMAT ddpfZBuffer;  // Passing this as a VOID* 
   /* hr = g_pD3D->EnumZBufferFormats( pDeviceGUID, EnumZBufferCallback, (VOID*)&ddpfZBuffer );
    if( FAILED( hr ) ) { error( hr, "D3D:CreateSurface:EnumZBuffer" );return hr; }

     // If the enumerated format is good (it should be), the 
    // dwSize member will be properly initialized. Check this
    // just in case.
    if( sizeof(DDPIXELFORMAT) != ddpfZBuffer.dwSize )
     { error( hr, "D3D:CreateSurface:ZBuffer:Pixelformat" );return hr; }*/

      // Bittiefe einstellen
    ZeroMemory( &ddpfZBuffer, sizeof(DDPIXELFORMAT) );
    ddpfZBuffer.dwSize         = sizeof(DDPIXELFORMAT);
    ddpfZBuffer.dwFlags        = DDPF_ZBUFFER;
    ddpfZBuffer.dwZBufferBitDepth = 32;
    ddpfZBuffer.dwZBitMask = 0xFFFFFFFF;

    // Get z-buffer dimensions from the render target

    // Setup the surface desc for the z-buffer.
    ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
    ddsd.dwSize         = sizeof(DDSURFACEDESC2);
    ddsd.dwFlags        = DDSD_CAPS|DDSD_WIDTH|DDSD_HEIGHT|DDSD_PIXELFORMAT;
    ddsd.dwWidth        = param.win_xsize;
    ddsd.dwHeight       = param.win_ysize;
    ddsd.ddpfPixelFormat = ddpfZBuffer;
    //memcpy( &ddsd.ddpfPixelFormat, &ddpfZBuffer, sizeof(DDPIXELFORMAT) ); 

    // Software devices require system-memory depth buffers.
    if ( param.driver == 1 ) ddsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_VIDEOMEMORY;
    if ( param.driver == 2 ) ddsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_SYSTEMMEMORY;

   

    // Create the depth-buffer. 
    hr = g_pDD4->CreateSurface( &ddsd, &g_pddsZBuffer, NULL );
    if( FAILED( hr ) ) { error( hr, "D3D:CreateSurface:ZBuffer" );return hr; }

    // Attach the z-buffer to the back buffer.
    hr = g_pddsBackBuffer->AddAttachedSurface( g_pddsZBuffer );
    if( FAILED( hr ) ) { error( hr, "D3D:CreateSurface:AddAttachedSurface" );return hr; }
        
    
    
    return 0;
}

// Initialisierung der Surfaces
HRESULT _device3d::initsurfaces() {

    HRESULT hr;
    
    // Wenn noch Main Surfaces bestehen, diese zerstren
    if( g_pddsZBuffer ) g_pddsZBuffer->Release();
    if( g_pddsBackBuffer ) g_pddsBackBuffer->Release();
    if( g_pddsPrimary ) g_pddsPrimary->Release();
    g_pddsZBuffer = NULL;
    g_pddsBackBuffer = NULL;
    g_pddsPrimary = NULL;
    
    // Prepare a surface description for the primary surface.
    DDSURFACEDESC2 ddsd;
    ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
    ddsd.dwSize         = sizeof(DDSURFACEDESC2);
 
    if ( param.mode == 1 ) {
        ddsd.dwFlags        = DDSD_CAPS;
        if ( param.driver == 1 ) ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_VIDEOMEMORY;
        if ( param.driver == 2 ) ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_SYSTEMMEMORY;
        // Create the primary surface.
        hr = g_pDD4->CreateSurface( &ddsd, &g_pddsPrimary, NULL );
        if( FAILED( hr ) ) { error( hr, "D3D:CreateSurface:Primary" );return hr; }
    
        ddsd.dwFlags        =  DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
        if ( param.driver == 1 ) {
            ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE;
            // ddsd.ddsCaps.dwCaps2 = DDSCAPS2_HINTANTIALIASING; // ? funzt irgendwie noch nicht
        }
        if ( param.driver == 2 ) {
            ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_SYSTEMMEMORY;
        }
        
        // Set the dimensions of the back buffer. Note that if our window changes
        // size, we need to destroy this surface and create a new one.  
        GetClientRect( hWnd, &g_rcScreenRect );
        GetClientRect( hWnd, &g_rcViewportRect );
        ClientToScreen( hWnd, (POINT*)&g_rcScreenRect.left );
        ClientToScreen( hWnd, (POINT*)&g_rcScreenRect.right );
        ddsd.dwWidth  = g_rcScreenRect.right - g_rcScreenRect.left;
        ddsd.dwHeight = g_rcScreenRect.bottom - g_rcScreenRect.top;
    
        // Umkonvertierung in ein D3D Format
        g_d3dScreenRect.x1 = 0;
        g_d3dScreenRect.y1 = 0;
        g_d3dScreenRect.x2 =  g_rcScreenRect.right - g_rcScreenRect.left;
        g_d3dScreenRect.y2 = g_rcScreenRect.bottom - g_rcScreenRect.top;
    
        // Setzen der Windowsgrenvariable
        param.win_xsize = g_rcScreenRect.right - g_rcScreenRect.left;
        param.win_ysize = g_rcScreenRect.bottom - g_rcScreenRect.top;
      
        // Create the back buffer. The most likely reason for failure is running
        // out of video memory. (A more sophisticated app should handle this.)
        hr = g_pDD4->CreateSurface( &ddsd, &g_pddsBackBuffer, NULL );
        if( FAILED( hr ) ) { error( hr, "D3D:CreateSurface:Back" );return hr; }

      // initzbuffer();
 
      /*  // Create z-buffer
        ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
       ddsd.dwSize         = sizeof(DDSURFACEDESC2);
       ddsd.dwFlags        =  DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS | DDSD_ZBUFFERBITDEPTH;
       //ddsd.dwZBufferBitDepth = 16;
       ddsd.dwWidth = param.win_xsize;
       ddsd.dwHeight = param.win_ysize;
        if ( param.driver == 1 ) ddsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_VIDEOMEMORY;
        if ( param.driver == 2 ) ddsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_SYSTEMMEMORY;
        hr = g_pDD4->CreateSurface( &ddsd, &g_pddsZBuffer, NULL );
        if( FAILED( hr ) ) { error( hr, "D3D:CreateSurface:ZBuffer" );return hr; }
        hr = g_pddsBackBuffer->AddAttachedSurface(g_pddsZBuffer);
        if( FAILED( hr ) )  { error( hr, "D3D:M2Init:AddAttachedSurfaceSurface:ZBuffer" );return hr; }
        g_pd3dDevice->SetRenderState( D3DRENDERSTATE_ZENABLE,TRUE );
        //g_pd3dDevice->SetRenderState( D3DRENDERSTATE_ZWRITEABLE,TRUE );*/
        
    
        LPDIRECTDRAWCLIPPER pcClipper;
        // Create the clipper.
        hr = g_pDD4->CreateClipper( 0, &pcClipper, NULL );
        if( FAILED( hr ) )  { error( hr, "D3D:CreateClipper" );return hr; }
         
        // Assign it to the window handle, then set
        // the clipper to the desired surface.
        pcClipper->SetHWnd( 0, hWnd );
        g_pddsPrimary->SetClipper( pcClipper );
        pcClipper->Release();
    }

    if ( param.mode == 2 ) {

        // Primary Surface
        ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
        ddsd.dwSize         = sizeof(DDSURFACEDESC2); 
        ddsd.dwFlags        = DDSD_CAPS;
        if ( param.driver == 1 ) ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
        if ( param.driver == 2 ) ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_SYSTEMMEMORY;
        hr = g_pDD4->CreateSurface(&ddsd, &g_pddsPrimary, NULL);
        if( FAILED( hr ) )  { error( hr, "D3D:M2Init:CreateSurface" );return hr; }

        // Backbuffer
        ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
        ddsd.dwSize         = sizeof(DDSURFACEDESC2);
        ddsd.dwFlags       = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
        ddsd.dwWidth = 640;
        ddsd.dwHeight = 480;
        if ( param.driver == 1 ) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_VIDEOMEMORY;
        if ( param.driver == 2 ) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_SYSTEMMEMORY;
        hr = g_pDD4->CreateSurface(&ddsd, &g_pddsBackBuffer, NULL);
        if( FAILED( hr ) )  { error( hr, "D3D:M2Init:CreateSurface:BackBuffer" );return hr; }
        hr = g_pddsPrimary->AddAttachedSurface(g_pddsBackBuffer);
        if( FAILED( hr ) )  { error( hr, "D3D:M2Init:AddAttachedSurfaceSurface:BackBuffer" );return hr; }
        
        g_rcViewportRect. top = 0;
        g_rcViewportRect.bottom = 480;
        g_rcViewportRect.left = 0;
        g_rcViewportRect.right = 640;

        g_rcScreenRect.top = 0;
        g_rcScreenRect.bottom = 480;
        g_rcScreenRect.left = 0;
        g_rcScreenRect.right = 640;
        // Umkonvertierung in ein D3D Format
        g_d3dScreenRect.x1 = 0;
        g_d3dScreenRect.y1 = 0;
        g_d3dScreenRect.x2 =  640;
        g_d3dScreenRect.y2 = 480;
        param.win_xsize = 640;
        param.win_ysize = 480;
    }

    return 0;
}

// Initialisierung der Surfaces
HRESULT _device3d::initdriver() {
    HRESULT hr;
    // berprfen ob es schon einen gibt
    if( g_pd3dDevice ) g_pd3dDevice->Release();
    g_pd3dDevice = NULL;
    
    // Nur Hardware
    if ( param.driver == 1 ) {
        hr = g_pD3D->CreateDevice( IID_IDirect3DHALDevice,g_pddsBackBuffer,&g_pd3dDevice, NULL );
        if( FAILED( hr ) )  { error( hr , "D3D:CreateDevice" );return hr; }
    }

    // Nur Software
    if ( param.driver == 2 ) {
        hr = g_pD3D->CreateDevice( IID_IDirect3DRGBDevice,g_pddsBackBuffer,&g_pd3dDevice, NULL );
        if( FAILED( hr ) )  { error( hr , "D3D:CreateDevice" );return hr; }
    }
    
    // Beides ausprobieren
     if ( param.driver == 3 ) {
        hr = g_pD3D->CreateDevice( IID_IDirect3DHALDevice,g_pddsBackBuffer,&g_pd3dDevice, NULL );
        if( FAILED( hr ) )  {
            hr = g_pD3D->CreateDevice( IID_IDirect3DRGBDevice,g_pddsBackBuffer,&g_pd3dDevice, NULL );
            if( FAILED( hr ) )  { error( hr , "D3D:CreateDevice" );return hr; }
        }
    }

    // Enable z-buffering
    g_pd3dDevice->SetRenderState( D3DRENDERSTATE_ZENABLE, TRUE );
    g_pd3dDevice->SetRenderState( D3DRENDERSTATE_ZWRITEENABLE, TRUE );

    // Colorkey einfachlaten
    g_pd3dDevice->SetRenderState( D3DRENDERSTATE_COLORKEYENABLE , TRUE );

    return 0;
}

// Initialisierung
HRESULT _device3d::init( HWND hWnd2 ) {

    DDSURFACEDESC2 ddsd;

    HRESULT hr;

    hWnd = hWnd2;

    // Create a DirectDraw object.
    hr = DirectDrawCreate( NULL, &g_pDD1, NULL );
    if( FAILED( hr ) ) { error( hr, "D3D:DirectDrawCreate" );return hr; }

    // Get a ptr to an IDirectDraw4 interface. This interface to DirectDraw
    // represents the DX6 version of the API.
    hr = g_pDD1->QueryInterface( IID_IDirectDraw4, (VOID**)&g_pDD4 );
    if( FAILED( hr ) ) { error( hr, "D3D:QueryInterface4" );return hr; }
       
     // Set Cooperative Level 
     if ( param.mode == 1 ) {
         hr = g_pDD4->SetCooperativeLevel( hWnd, DDSCL_NORMAL );
         if( FAILED( hr ) )  { error( hr, "D3D:SetCooperativeLevel" );return hr; }
     }
     if ( param.mode == 2 ) {
         hr = g_pDD4->SetCooperativeLevel( hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
         if( FAILED( hr ) )  { error( hr, "D3D:SetCooperativeLevel" );return hr; }
     }

     // Display Modus
     if ( param.mode == 2 ) {
         hr = g_pDD4->SetDisplayMode(640,480,16,NULL,NULL);
         if( FAILED( hr ) )  { error( hr, "D3D:SetDisplayMode" );return hr; }
     }
       
     // Query DirectDraw for access to Direct3D
    g_pDD4->QueryInterface( IID_IDirect3D3, (VOID**)&g_pD3D );
    if( FAILED( hr) ) { error( hr, "D3D:QueryInterface3" );return hr; }

    // Die Surfaces initialisieren
    initsurfaces();
    
    // Query DirectDraw for access to Direct3D
    g_pDD4->QueryInterface( IID_IDirect3D3, (VOID**)&g_pD3D );
    if( FAILED( hr) ) { error( hr, "D3D:QueryInterface3.2" );return hr; }

    // Check the display mode
    if ( param.mode == 1 ) {
        ddsd.dwSize = sizeof(DDSURFACEDESC2);
        g_pDD4->GetDisplayMode( &ddsd );
        if( ddsd.ddpfPixelFormat.dwRGBBitCount <= 8 )
            return DDERR_INVALIDMODE;
    }

    // ZBuffer aktivieren
    initzbuffer();

    // Driver aktivieren
    initdriver();
   
    // Viewport aktivieren
    initviewport();

    param.active = TRUE;
    
    return 0;
}

// Alles Deinitialisieren
HRESULT _device3d::deinit() {
    HRESULT hr;
    
    // Display Modus zurcksetzen
  /*  if ( param.mode == 2 ) {
    hr = g_pDD4->RestoreDisplayMode();
            if( FAILED( hr ) )  { error( hr, "D3D:RestoreDisplayMode" );return hr; }
    }*/
    
    // Alle Objekte befreien
    if( g_pvViewport ) g_pvViewport->Release();
    if( g_pD3D ) g_pD3D->Release();
    if( g_pddsBackBuffer ) g_pddsBackBuffer->Release();
    if( g_pddsPrimary ) g_pddsPrimary->Release();
    if( g_pDD4 ) g_pDD4->Release();
    if( g_pd3dDevice )
     if( 0 < g_pd3dDevice->Release() )
            return E_FAIL;     
    if( g_pDD1 )
     if( 0 < g_pDD1->Release() )
               return E_FAIL; 
    g_pvViewport = NULL;
    g_pd3dDevice = NULL;
    g_pD3D = NULL;
    g_pddsBackBuffer = NULL;
    g_pddsPrimary = NULL;
    g_pDD4 = NULL;
    g_pDD1 = NULL;
    return S_OK;
}

HRESULT _device3d::flip() {
    HRESULT hr;
    
    // Windowed Mode
    if ( param.mode == 1 ) {
        if ( NULL == g_pddsPrimary ) return E_FAIL;
        hr = g_pddsPrimary->Blt( &g_rcScreenRect, g_pddsBackBuffer, &g_rcViewportRect, DDBLT_WAIT, NULL );
        if( FAILED( hr ) )  { error( hr, "D3D:flip:blt" );return hr; }
    }
  
    // Fullscreen Mode
    if ( param.mode == 2 ) {
        if ( NULL == g_pddsPrimary ) return E_FAIL;
        g_pddsPrimary->Flip( NULL , DDFLIP_WAIT );
        if( FAILED( hr ) )  { error( hr, "D3D:flip:fullscreensflip" );return hr; }
    }
    return 0;
}

HRESULT _device3d::gettxtsurface( LPDIRECTDRAWSURFACE4 * g_pddsSurface, int width, int height, int bitt ) {
    HRESULT hr;
    DDSURFACEDESC2 ddsd;
    DDPIXELFORMAT ddpf;

    // Bittiefe einstellen
    ZeroMemory( &ddpf, sizeof(DDPIXELFORMAT) );
    ddpf.dwSize         = sizeof(DDPIXELFORMAT);
    ddpf.dwFlags        = DDPF_RGB | DDPF_ALPHAPIXELS;
    ddpf.dwRGBBitCount = bitt;

    ddpf.dwRBitMask = 0x00007c00;
    ddpf.dwGBitMask = 0x000003e0;
    ddpf.dwBBitMask = 0x0000001f;
    ddpf.dwRGBAlphaBitMask = 0x00008000;

    // Surface Daten
    ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
    ddsd.dwSize         = sizeof(DDSURFACEDESC2);
    ddsd.dwFlags        = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS | DDSD_PIXELFORMAT;
    
    // Mit Texturemanagement
    if ( param.driver == 1 ) {
       if ( param.texturemanage == 1 ) {
            ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
        }
        if ( param.texturemanage == 2 ) {
            ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE;
            ddsd.ddsCaps.dwCaps2 = DDSCAPS2_TEXTUREMANAGE;
        }
    }
    if ( param.driver == 2 ) {
        if ( param.texturemanage == 1 ) {
            ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
        }
        if ( param.texturemanage == 2 ) {
            ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE;
            ddsd.ddsCaps.dwCaps2 = DDSCAPS2_TEXTUREMANAGE;
         }
    }
    ddsd.dwWidth  = width;
    ddsd.dwHeight = height;
    ddsd.ddpfPixelFormat = ddpf;

    // Create the  surface.
    hr = g_pDD4->CreateSurface( &ddsd, g_pddsSurface, NULL );
    if( FAILED( hr ) ) { error( hr, "D3D:getsurface:createsurface" );return hr; }
    return 0;
}

// Colorkeying
HRESULT _device3d::setcolorkey( LPDIRECTDRAWSURFACE4 g_pddsSurface, unsigned int color ) {
    DDCOLORKEY ddck;
    ddck.dwColorSpaceLowValue = color;
    ddck.dwColorSpaceHighValue = color;
    g_pddsSurface->SetColorKey( DDCKEY_SRCBLT , &ddck );
    return 0;
}

 // Ein Texture Interface anfordern und Verbinden
HRESULT _device3d::load( LPDIRECTDRAWSURFACE4 g_pddsSurface, LPDIRECT3DTEXTURE2 * lpD3DTexture2 ) {
    HRESULT hr;
    g_pddsSurface->QueryInterface ( IID_IDirect3DTexture2, (void**) lpD3DTexture2 );
    return 0;
}

HRESULT _device3d::settexture( LPDIRECT3DTEXTURE2 lpD3DTexture2 ) {
    HRESULT hr;   
    hr = g_pd3dDevice->SetTexture(0,lpD3DTexture2);
    if( FAILED( hr ) ) { error( hr, "D3D:settexture:settexture" );return hr; }
    return 0;
}

HRESULT _device3d::notexture() {
    HRESULT hr;   
    hr = g_pd3dDevice->SetTexture(0,NULL);
    if( FAILED( hr ) ) { error( hr, "D3D:notexture:settexture" );return hr; }
    return 0;
}

// Zeichnet ein Triangle
HRESULT _device3d::drawtriangle( D3DTLVERTEX Vertex1, D3DTLVERTEX Vertex2, D3DTLVERTEX Vertex3 ) {
    HRESULT hr;

    D3DTLVERTEX Vertex_List[3];
    Vertex_List[0] = Vertex1;
    Vertex_List[1] = Vertex2;
    Vertex_List[2] = Vertex3;

    // Triangle zeichnen 
   hr = g_pd3dDevice->DrawPrimitive( D3DPT_TRIANGLELIST, D3DFVF_TLVERTEX , &Vertex_List, 3, D3DDP_DONOTUPDATEEXTENTS  );
   if( FAILED( hr ) )  { error( hr, "D3D:drawtriangle:drawprimitive()" );return hr; }

    return 0;
}

// Zeichnet eine Linie
HRESULT _device3d::drawline( D3DTLVERTEX Vertex1, D3DTLVERTEX Vertex2 ) {
    HRESULT hr;

    D3DTLVERTEX Vertex_List[2];
    Vertex_List[0] = Vertex1;
    Vertex_List[1] = Vertex2;

    // Linie zeichnen 
    hr = g_pd3dDevice->DrawPrimitive( D3DPT_LINELIST, D3DFVF_TLVERTEX , &Vertex_List, 2, D3DDP_DONOTUPDATEEXTENTS  );
    if( FAILED( hr ) )  { error( hr, "D3D:drawline:drawprimitive()" );return hr; }

    return 0;
}

HRESULT _device3d::clear() {
        HRESULT hr;
       // hr = g_pvViewport->Clear2( 1UL, &g_d3dScreenRect , D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER , 0, 1.0, 0 );
        hr = g_pvViewport->Clear( 1UL, &g_d3dScreenRect , D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER );
        if( FAILED( hr ) )  { error( hr,  "D3D:clear()" );return hr; }
        return 0;
}

HRESULT _device3d::beginscene() {
        HRESULT hr;
        hr = g_pd3dDevice->BeginScene();
        if( FAILED( hr ) )  { error( hr, "D3D:drawtriangle:beginscene()" );return hr; }
        return 0;
}

HRESULT _device3d::endscene() {
        HRESULT hr;
        hr = g_pd3dDevice->EndScene();
        if( FAILED( hr ) )  { error( hr, "D3D:drawtriangle:endscene()" );return hr; }
        return 0;
}

HRESULT _device3d::rebuild() {
    initsurfaces();
    initzbuffer();
    initdriver();
    initviewport();
    return 0;
}
   
    
    


